// Don't modify, generated file from /home/iurt/rpmbuild/BUILD/aseprite-1.3.9.1-build/aseprite-1.3.9.1/data/pref.xml

#ifndef GENERATED_PREF_TYPES_H_INCLUDED
#define GENERATED_PREF_TYPES_H_INCLUDED
#pragma once

#include <string>

namespace app {
namespace gen {

  enum class RightClickMode {
    DEFAULT = 0,
    PAINT_BGCOLOR = 0,
    PICK_FGCOLOR = 1,
    ERASE = 2,
    SCROLL = 3,
    RECTANGULAR_MARQUEE = 4,
    LASSO = 5,
    SELECT_LAYER_AND_MOVE = 6,
  };

  enum class OnionskinType {
    MERGE = 0,
    RED_BLUE_TINT = 1,
  };

  enum class BrushType {
    CIRCLE = 0,
    SQUARE = 1,
    LINE = 2,
  };

  enum class BrushPreview {
    NONE = 0,
    EDGES = 1,
    FULL = 2,
    FULLALL = 3,
    FULLNEDGES = 4,
  };

  enum class BgType {
    CHECKERED_16x16 = 0,
    CHECKERED_8x8 = 1,
    CHECKERED_4x4 = 2,
    CHECKERED_2x2 = 3,
    CHECKERED_1x1 = 4,
    CHECKERED_CUSTOM = 5,
  };

  enum class StopAtGrid {
    NEVER = 0,
    IF_VISIBLE = 1,
    ALWAYS = 2,
  };

  enum class FillReferTo {
    ACTIVE_LAYER = 0,
    ALL_LAYERS = 1,
  };

  enum class PixelConnectivity {
    FOUR_CONNECTED = 0,
    EIGHT_CONNECTED = 1,
  };

  enum class EyedropperChannel {
    COLOR_ALPHA = 0,
    COLOR = 1,
    ALPHA = 2,
    RGBA = 3,
    RGB = 4,
    HSVA = 5,
    HSV = 6,
    HSLA = 7,
    HSL = 8,
    GRAYA = 9,
    GRAY = 10,
    INDEX = 11,
  };

  enum class EyedropperSample {
    ALL_LAYERS = 0,
    CURRENT_LAYER = 1,
    FIRST_REFERENCE_LAYER = 2,
  };

  enum class SelectionMode {
    DEFAULT = 0,
    REPLACE = 0,
    ADD = 1,
    SUBTRACT = 2,
    INTERSECT = 3,
  };

  enum class PivotPosition {
    NORTHWEST = 0,
    NORTH = 1,
    NORTHEAST = 2,
    WEST = 3,
    CENTER = 4,
    EAST = 5,
    SOUTHWEST = 6,
    SOUTH = 7,
    SOUTHEAST = 8,
  };

  enum class SymmetryMode {
    NONE = 0,
    HORIZONTAL = 1,
    VERTICAL = 2,
    BOTH = 3,
  };

  enum class PaintingCursorType {
    SIMPLE_CROSSHAIR = 0,
    CROSSHAIR_ON_SPRITE = 1,
  };

  enum class TimelinePosition {
    BOTTOM = 0,
    LEFT = 1,
    RIGHT = 2,
  };

  enum class ColorProfileBehavior {
    DISABLE = 0,
    EMBEDDED = 1,
    CONVERT = 2,
    ASSIGN = 3,
    ASK = 4,
  };

  enum class WindowColorProfile {
    MONITOR = 0,
    SRGB = 1,
    SPECIFIC = 2,
  };

  enum class ToGrayAlgorithm {
    DEFAULT = 0,
    LUMA = 0,
    HSV = 1,
    HSL = 2,
  };

  enum class SequenceDecision {
    ASK = 0,
    YES = 1,
    NO = 2,
  };

  enum class Downsampling {
    NEAREST = 0,
    BILINEAR = 1,
    BILINEAR_MIPMAP = 2,
    TRILINEAR_MIPMAP = 3,
  };

  enum class AlphaRange {
    EIGHT_BIT = 0,
    PERCENTAGE = 1,
  };

  class GlobalPref : public Section {
  public:
    explicit GlobalPref(const std::string& name);
    void load();
    void save() override;
    Section* section(const char* id) override;
    OptionBase* option(const char* id) override;

    class General : public Section {
    public:
      explicit General(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<std::string> language;
      Option<int> screenScale;
      Option<int> uiScale;
      Option<bool> gpuAcceleration;
      Option<bool> showHome;
      Option<bool> visibleTimeline;
      Option<bool> autoshowTimeline;
      Option<bool> rewindOnStop;
      Option<bool> expandMenubarOnMouseover;
      Option<bool> dataRecovery;
      Option<double> dataRecoveryPeriod;
      Option<bool> keepEditedSpriteData;
      Option<int> keepEditedSpriteDataFor;
      Option<bool> keepClosedSpriteOnMemory;
      Option<double> keepClosedSpriteOnMemoryFor;
      Option<bool> showFullPath;
      Option<TimelinePosition> timelinePosition;
      Option<int> timelineLayerPanelWidth;
      Option<bool> showMenuBar;
      Option<int> recentItems;
      Option<bool> osxAsyncView;
      Option<std::string> x11StylusId;
      std::vector<OptionBase*> optionList() const override;
    };
    General general;

    class Undo : public Section {
    public:
      explicit Undo(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<int> sizeLimit;
      Option<bool> gotoModified;
      Option<bool> allowNonlinearHistory;
      Option<bool> showTooltip;
      std::vector<OptionBase*> optionList() const override;
    };
    Undo undo;

    class Editor : public Section {
    public:
      explicit Editor(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> zoomWithWheel;
      Option<bool> zoomWithSlide;
      Option<bool> zoomFromCenterWithWheel;
      Option<bool> zoomFromCenterWithKeys;
      Option<bool> invertBrushSizeWheel;
      Option<bool> showScrollbars;
      Option<bool> autoScroll;
      Option<RightClickMode> rightClickMode;
      Option<bool> autoSelectLayer;
      Option<bool> autoSelectLayerQuick;
      Option<bool> straightLinePreview;
      Option<bool> playOnce;
      Option<bool> playAll;
      Option<bool> playSubtags;
      Option<bool> autoFit;
      Option<Downsampling> downsampling;
      std::vector<OptionBase*> optionList() const override;
    };
    Editor editor;

    class Cels : public Section {
    public:
      explicit Cels(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> userDataVisibility;
      std::vector<OptionBase*> optionList() const override;
    };
    Cels cels;

    class Layers : public Section {
    public:
      explicit Layers(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> userDataVisibility;
      std::vector<OptionBase*> optionList() const override;
    };
    Layers layers;

    class Sprite : public Section {
    public:
      explicit Sprite(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> userDataVisibility;
      std::vector<OptionBase*> optionList() const override;
    };
    Sprite sprite;

    class Tags : public Section {
    public:
      explicit Tags(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> userDataVisibility;
      std::vector<OptionBase*> optionList() const override;
    };
    Tags tags;

    class Timeline : public Section {
    public:
      explicit Timeline(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> keepSelection;
      Option<bool> selectOnClick;
      Option<bool> selectOnClickWithKey;
      Option<bool> selectOnDrag;
      Option<bool> dragAndDropFromEdges;
      std::vector<OptionBase*> optionList() const override;
    };
    Timeline timeline;

    class Cursor : public Section {
    public:
      explicit Cursor(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> useNativeCursor;
      Option<int> cursorScale;
      Option<app::Color> cursorColor;
      Option<PaintingCursorType> paintingCursorType;
      Option<BrushPreview> brushPreview;
      Option<bool> snapToGrid;
      std::vector<OptionBase*> optionList() const override;
    };
    Cursor cursor;

    class Preview : public Section {
    public:
      explicit Preview(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> playOnce;
      Option<bool> playAll;
      Option<bool> playSubtags;
      std::vector<OptionBase*> optionList() const override;
    };
    Preview preview;

    class Theme : public Section {
    public:
      explicit Theme(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<std::string> selected;
      Option<std::string> font;
      Option<std::string> miniFont;
      std::vector<OptionBase*> optionList() const override;
    };
    Theme theme;

    class Tablet : public Section {
    public:
      explicit Tablet(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<std::string> api;
      Option<bool> setCursorFix;
      std::vector<OptionBase*> optionList() const override;
    };
    Tablet tablet;

    class Experimental : public Section {
    public:
      explicit Experimental(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> multipleWindows;
      Option<bool> newRenderEngine;
      Option<bool> newBlend;
      Option<bool> useNativeClipboard;
      Option<bool> useNativeFileDialog;
      Option<bool> useShadersForColorSelectors;
      Option<bool> hueWithSatValueForColorSelector;
      Option<bool> oneFingerAsMouseMovement;
      Option<bool> loadWintabDriver;
      Option<bool> flashLayer;
      Option<int> nonactiveLayersOpacity;
      Option<int> nonactiveLayersOpacityPreview;
      std::vector<OptionBase*> optionList() const override;
    };
    Experimental experimental;

    class News : public Section {
    public:
      explicit News(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<std::string> cacheFile;
      std::vector<OptionBase*> optionList() const override;
    };
    News news;

    class StatusBar : public Section {
    public:
      explicit StatusBar(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> focusFrameFieldOnMouseover;
      std::vector<OptionBase*> optionList() const override;
    };
    StatusBar statusBar;

    class ColorBar : public Section {
    public:
      explicit ColorBar(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<int> boxSize;
      Option<int> tilesBoxSize;
      Option<app::Color> fgColor;
      Option<app::Color> bgColor;
      Option<doc::tile_t> fgTile;
      Option<doc::tile_t> bgTile;
      Option<app::ColorBar::ColorSelector> selector;
      Option<bool> discreteWheel;
      Option<int> wheelModel;
      Option<int> harmony;
      Option<bool> showInvalidFgBgColorAlert;
      Option<bool> entriesSeparator;
      Option<bool> showColorAndTiles;
      Option<app::TilesetMode> defaultTilesetMode;
      std::vector<OptionBase*> optionList() const override;
    };
    ColorBar colorBar;

    class Updater : public Section {
    public:
      explicit Updater(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<int> inits;
      Option<int> exits;
      Option<bool> isDeveloper;
      Option<double> waitDays;
      Option<int> lastCheck;
      Option<std::string> uuid;
      Option<std::string> currentVersion;
      Option<std::string> newVersion;
      Option<std::string> newUrl;
      std::vector<OptionBase*> optionList() const override;
    };
    Updater updater;

    class Brush : public Section {
    public:
      explicit Brush(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<doc::BrushPattern> pattern;
      std::vector<OptionBase*> optionList() const override;
    };
    Brush brush;

    class SaveBrush : public Section {
    public:
      explicit SaveBrush(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> brushType;
      Option<bool> brushSize;
      Option<bool> brushAngle;
      Option<bool> fgColor;
      Option<bool> bgColor;
      Option<bool> imageColor;
      Option<bool> inkType;
      Option<bool> inkOpacity;
      Option<bool> shade;
      Option<bool> pixelPerfect;
      std::vector<OptionBase*> optionList() const override;
    };
    SaveBrush saveBrush;

    class Selection : public Section {
    public:
      explicit Selection(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<SelectionMode> mode;
      Option<bool> moveEdges;
      Option<bool> modifiersDisableHandles;
      Option<bool> moveOnAddMode;
      Option<bool> pivotVisibility;
      Option<PivotPosition> pivotPosition;
      Option<bool> opaque;
      Option<bool> autoOpaque;
      Option<bool> keepSelectionAfterClear;
      Option<bool> autoShowSelectionEdges;
      Option<app::Color> transparentColor;
      Option<app::tools::RotationAlgorithm> rotationAlgorithm;
      Option<int> modifySelectionQuantity;
      Option<BrushType> modifySelectionBrush;
      Option<bool> doubleclickSelectTile;
      Option<bool> forceRotsprite;
      Option<bool> multicelWhenLayersOrFrames;
      Option<bool> snapToGrid;
      std::vector<OptionBase*> optionList() const override;
    };
    Selection selection;

    class Quantization : public Section {
    public:
      explicit Quantization(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> withAlpha;
      Option<std::string> ditheringAlgorithm;
      Option<int> ditheringFactor;
      Option<ToGrayAlgorithm> toGray;
      Option<bool> advanced;
      Option<doc::RgbMapAlgorithm> rgbmapAlgorithm;
      Option<doc::FitCriteria> fitCriteria;
      std::vector<OptionBase*> optionList() const override;
    };
    Quantization quantization;

    class Eyedropper : public Section {
    public:
      explicit Eyedropper(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<EyedropperChannel> channel;
      Option<EyedropperSample> sample;
      Option<bool> discardBrush;
      std::vector<OptionBase*> optionList() const override;
    };
    Eyedropper eyedropper;

    class Shared : public Section {
    public:
      explicit Shared(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> shareDynamics;
      Option<bool> shareInk;
      Option<app::tools::InkType> ink;
      std::vector<OptionBase*> optionList() const override;
    };
    Shared shared;

    class NewFile : public Section {
    public:
      explicit NewFile(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<int> width;
      Option<int> height;
      Option<doc::ColorMode> colorMode;
      Option<int> backgroundColor;
      Option<bool> advanced;
      Option<std::string> pixelRatio;
      std::vector<OptionBase*> optionList() const override;
    };
    NewFile newFile;

    class FileSelector : public Section {
    public:
      explicit FileSelector(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<std::string> currentFolder;
      Option<double> zoom;
      std::vector<OptionBase*> optionList() const override;
    };
    FileSelector fileSelector;

    class TextTool : public Section {
    public:
      explicit TextTool(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<std::string> fontFace;
      Option<int> fontSize;
      Option<bool> antialias;
      std::vector<OptionBase*> optionList() const override;
    };
    TextTool textTool;

    class SymmetryMode : public Section {
    public:
      explicit SymmetryMode(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> enabled;
      std::vector<OptionBase*> optionList() const override;
    };
    SymmetryMode symmetryMode;

    class Perf : public Section {
    public:
      explicit Perf(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> showRenderTime;
      std::vector<OptionBase*> optionList() const override;
    };
    Perf perf;

    class Guides : public Section {
    public:
      explicit Guides(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<app::Color> layerEdgesColor;
      Option<app::Color> autoGuidesColor;
      std::vector<OptionBase*> optionList() const override;
    };
    Guides guides;

    class Slices : public Section {
    public:
      explicit Slices(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<app::Color> defaultColor;
      Option<bool> userDataVisibility;
      std::vector<OptionBase*> optionList() const override;
    };
    Slices slices;

    class AdvancedMode : public Section {
    public:
      explicit AdvancedMode(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> showAlert;
      std::vector<OptionBase*> optionList() const override;
    };
    AdvancedMode advancedMode;

    class OpenFile : public Section {
    public:
      explicit OpenFile(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<SequenceDecision> openSequence;
      std::vector<OptionBase*> optionList() const override;
    };
    OpenFile openFile;

    class SaveFile : public Section {
    public:
      explicit SaveFile(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> showFileFormatDoesntSupportAlert;
      Option<bool> showExportAnimationInSequenceAlert;
      Option<std::string> defaultExtension;
      std::vector<OptionBase*> optionList() const override;
    };
    SaveFile saveFile;

    class ExportFile : public Section {
    public:
      explicit ExportFile(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> showOverwriteFilesAlert;
      Option<std::string> imageDefaultExtension;
      Option<std::string> animationDefaultExtension;
      std::vector<OptionBase*> optionList() const override;
    };
    ExportFile exportFile;

    class SpriteSheet : public Section {
    public:
      explicit SpriteSheet(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> showOverwriteFilesAlert;
      Option<std::string> defaultExtension;
      Option<bool> preview;
      Option<std::string> sections;
      std::vector<OptionBase*> optionList() const override;
    };
    SpriteSheet spriteSheet;

    class Gif : public Section {
    public:
      explicit Gif(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> showAlert;
      Option<bool> interlaced;
      Option<bool> loop;
      Option<bool> preservePaletteOrder;
      std::vector<OptionBase*> optionList() const override;
    };
    Gif gif;

    class Jpeg : public Section {
    public:
      explicit Jpeg(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> showAlert;
      Option<double> quality;
      std::vector<OptionBase*> optionList() const override;
    };
    Jpeg jpeg;

    class Svg : public Section {
    public:
      explicit Svg(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> showAlert;
      Option<int> pixelScale;
      std::vector<OptionBase*> optionList() const override;
    };
    Svg svg;

    class Tga : public Section {
    public:
      explicit Tga(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> showAlert;
      Option<int> bitsPerPixel;
      Option<bool> compress;
      std::vector<OptionBase*> optionList() const override;
    };
    Tga tga;

    class Css : public Section {
    public:
      explicit Css(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> showAlert;
      Option<int> pixelScale;
      Option<bool> withVars;
      Option<bool> generateHtml;
      std::vector<OptionBase*> optionList() const override;
    };
    Css css;

    class Webp : public Section {
    public:
      explicit Webp(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> showAlert;
      Option<bool> loop;
      Option<int> type;
      Option<int> quality;
      Option<int> compression;
      Option<int> imageHint;
      Option<int> imagePreset;
      std::vector<OptionBase*> optionList() const override;
    };
    Webp webp;

    class HueSaturation : public Section {
    public:
      explicit HueSaturation(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<filters::HueSaturationFilter::Mode> mode;
      std::vector<OptionBase*> optionList() const override;
    };
    HueSaturation hueSaturation;

    class Filters : public Section {
    public:
      explicit Filters(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<CelsTarget> celsTarget;
      std::vector<OptionBase*> optionList() const override;
    };
    Filters filters;

    class Scripts : public Section {
    public:
      explicit Scripts(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> showRunScriptAlert;
      std::vector<OptionBase*> optionList() const override;
    };
    Scripts scripts;

    class Color : public Section {
    public:
      explicit Color(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> manage;
      Option<std::string> workingRgbSpace;
      Option<ColorProfileBehavior> filesWithProfile;
      Option<ColorProfileBehavior> missingProfile;
      Option<WindowColorProfile> windowProfile;
      Option<std::string> windowProfileName;
      std::vector<OptionBase*> optionList() const override;
    };
    Color color;

    class Range : public Section {
    public:
      explicit Range(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<AlphaRange> alpha;
      Option<AlphaRange> opacity;
      std::vector<OptionBase*> optionList() const override;
    };
    Range range;

    class CanvasSize : public Section {
    public:
      explicit CanvasSize(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> trimOutside;
      std::vector<OptionBase*> optionList() const override;
    };
    CanvasSize canvasSize;

    class Tileset : public Section {
    public:
      explicit Tileset(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<int> baseIndex;
      Option<bool> cacheCompressedTilesets;
      Option<bool> advanced;
      std::vector<OptionBase*> optionList() const override;
    };
    Tileset tileset;

    class Tilemap : public Section {
    public:
      explicit Tilemap(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> showDeleteUnusedTilesetAlert;
      std::vector<OptionBase*> optionList() const override;
    };
    Tilemap tilemap;
    std::vector<Section*> sectionList() const override;
  };

  class ToolPref : public Section {
  public:
    explicit ToolPref(const std::string& name);
    void load();
    void save() override;
    Section* section(const char* id) override;
    OptionBase* option(const char* id) override;
    Option<int> opacity;
    Option<int> tolerance;
    Option<bool> contiguous;
    Option<bool> filled;
    Option<bool> filledPreview;
    Option<app::tools::InkType> ink;
    Option<app::tools::FreehandAlgorithm> freehandAlgorithm;

    class Brush : public Section {
    public:
      explicit Brush(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<BrushType> type;
      Option<int> size;
      Option<int> angle;
      std::vector<OptionBase*> optionList() const override;
    };
    Brush brush;

    class Spray : public Section {
    public:
      explicit Spray(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<int> width;
      Option<int> speed;
      std::vector<OptionBase*> optionList() const override;
    };
    Spray spray;

    class Floodfill : public Section {
    public:
      explicit Floodfill(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<StopAtGrid> stopAtGrid;
      Option<FillReferTo> referTo;
      Option<PixelConnectivity> pixelConnectivity;
      std::vector<OptionBase*> optionList() const override;
    };
    Floodfill floodfill;

    class Dynamics : public Section {
    public:
      explicit Dynamics(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> stabilizer;
      Option<int> stabilizerFactor;
      Option<app::tools::DynamicSensor> size;
      Option<app::tools::DynamicSensor> angle;
      Option<app::tools::DynamicSensor> gradient;
      Option<int> minSize;
      Option<int> minAngle;
      Option<app::tools::ColorFromTo> colorFromTo;
      Option<std::string> matrixName;
      Option<double> minPressureThreshold;
      Option<double> maxPressureThreshold;
      Option<double> minVelocityThreshold;
      Option<double> maxVelocityThreshold;
      std::vector<OptionBase*> optionList() const override;
    };
    Dynamics dynamics;
    std::vector<OptionBase*> optionList() const override;
    std::vector<Section*> sectionList() const override;
  };

  class DocPref : public Section {
  public:
    explicit DocPref(const std::string& name);
    void load();
    void save() override;
    Section* section(const char* id) override;
    OptionBase* option(const char* id) override;

    class Site : public Section {
    public:
      explicit Site(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<doc::frame_t> frame;
      Option<doc::layer_t> layer;
      std::vector<OptionBase*> optionList() const override;
    };
    Site site;

    class Tiled : public Section {
    public:
      explicit Tiled(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<filters::TiledMode> mode;
      std::vector<OptionBase*> optionList() const override;
    };
    Tiled tiled;

    class Symmetry : public Section {
    public:
      explicit Symmetry(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<SymmetryMode> mode;
      Option<double> xAxis;
      Option<double> yAxis;
      std::vector<OptionBase*> optionList() const override;
    };
    Symmetry symmetry;

    class Grid : public Section {
    public:
      explicit Grid(const std::string& name);
      void forceSection();
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> snap;
      Option<gfx::Rect> bounds;
      Option<app::Color> color;
      Option<int> opacity;
      Option<bool> autoOpacity;
      std::vector<OptionBase*> optionList() const override;
    };
    Grid grid;

    class PixelGrid : public Section {
    public:
      explicit PixelGrid(const std::string& name);
      void forceSection();
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<app::Color> color;
      Option<int> opacity;
      Option<bool> autoOpacity;
      std::vector<OptionBase*> optionList() const override;
    };
    PixelGrid pixelGrid;

    class Bg : public Section {
    public:
      explicit Bg(const std::string& name);
      void forceSection();
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<BgType> type;
      Option<gfx::Size> size;
      Option<bool> zoom;
      Option<app::Color> color1;
      Option<app::Color> color2;
      std::vector<OptionBase*> optionList() const override;
    };
    Bg bg;

    class Timeline : public Section {
    public:
      explicit Timeline(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<int> firstFrame;
      std::vector<OptionBase*> optionList() const override;
    };
    Timeline timeline;

    class Thumbnails : public Section {
    public:
      explicit Thumbnails(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<double> zoom;
      Option<bool> enabled;
      Option<bool> overlayEnabled;
      Option<int> overlaySize;
      std::vector<OptionBase*> optionList() const override;
    };
    Thumbnails thumbnails;

    class Onionskin : public Section {
    public:
      explicit Onionskin(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> active;
      Option<int> prevFrames;
      Option<int> nextFrames;
      Option<int> opacityBase;
      Option<int> opacityStep;
      Option<OnionskinType> type;
      Option<bool> loopTag;
      Option<bool> currentLayer;
      Option<render::OnionskinPosition> position;
      std::vector<OptionBase*> optionList() const override;
    };
    Onionskin onionskin;

    class SaveCopy : public Section {
    public:
      explicit SaveCopy(const std::string& name);
      void clearSection();
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<std::string> filename;
      Option<double> resizeScale;
      Option<std::string> area;
      Option<std::string> layer;
      Option<int> layerIndex;
      Option<std::string> frameTag;
      Option<doc::AniDir> aniDir;
      Option<bool> applyPixelRatio;
      Option<bool> forTwitter;
      Option<bool> playSubtags;
      std::vector<OptionBase*> optionList() const override;
    };
    SaveCopy saveCopy;

    class SpriteSheet : public Section {
    public:
      explicit SpriteSheet(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> defined;
      Option<app::SpriteSheetType> type;
      Option<int> columns;
      Option<int> rows;
      Option<int> width;
      Option<int> height;
      Option<std::string> textureFilename;
      Option<std::string> dataFilename;
      Option<SpriteSheetDataFormat> dataFormat;
      Option<std::string> filenameFormat;
      Option<std::string> tagnameFormat;
      Option<int> borderPadding;
      Option<int> shapePadding;
      Option<int> innerPadding;
      Option<bool> trimSprite;
      Option<bool> trim;
      Option<bool> trimByGrid;
      Option<bool> extrude;
      Option<bool> mergeDuplicates;
      Option<bool> ignoreEmpty;
      Option<bool> openGenerated;
      Option<std::string> layer;
      Option<int> layerIndex;
      Option<std::string> frameTag;
      Option<bool> splitLayers;
      Option<bool> splitTags;
      Option<bool> splitGrid;
      Option<bool> listLayers;
      Option<bool> listFrameTags;
      Option<bool> listSlices;
      std::vector<OptionBase*> optionList() const override;
    };
    SpriteSheet spriteSheet;

    class ImportSpriteSheet : public Section {
    public:
      explicit ImportSpriteSheet(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<app::SpriteSheetType> type;
      Option<gfx::Rect> bounds;
      Option<bool> paddingEnabled;
      Option<gfx::Size> paddingBounds;
      Option<bool> partialTiles;
      std::vector<OptionBase*> optionList() const override;
    };
    ImportSpriteSheet importSpriteSheet;

    class Preview : public Section {
    public:
      explicit Preview(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<double> zoom;
      Option<gfx::Point> scroll;
      Option<bool> autoScroll;
      std::vector<OptionBase*> optionList() const override;
    };
    Preview preview;

    class Show : public Section {
    public:
      explicit Show(const std::string& name);
      void load();
      void save() override;
      Section* section(const char* id) override;
      OptionBase* option(const char* id) override;
      Option<bool> layerEdges;
      Option<bool> selectionEdges;
      Option<bool> grid;
      Option<bool> pixelGrid;
      Option<bool> brushPreview;
      Option<bool> slices;
      Option<bool> autoGuides;
      Option<bool> tileNumbers;
      std::vector<OptionBase*> optionList() const override;
    };
    Show show;
    std::vector<Section*> sectionList() const override;
  };

} // namespace gen
} // namespace app

#endif
